std.print("\n\n---function usage");
std.print("f(4) = "+f(4));    
def f(x) { 
   var y = 2*x;
   return y;
}

var global = 5;
def addGlobal(x) {
   global = global+x;
   std.print("x+global= "+global);
   return global;
}


std.print("\n\n---struct usage");
struct User { var name; var password; }
u = new User;  
u.name = "ab'";
u.name = u.name+"efg";
std.print(u);
u.name = null;
std.print(u);


std.print("\n\n---math operator usage");
x = 12;
y = 6;
std.print("x+y=",x+y);
std.print("x-y=",x-y);
std.print("x*y=",x*y);
std.print("x/y=",x/y);
std.print("x+y*5=",x+y*5);
std.print("x+y+x=",x+y+x);

std.print("\n\n---sign operator usage");
s_x = -12;
s_y = -6;
std.print("s_x="+s_x);
std.print("s_x+s_y="+(s_x+s_y));
std.print("-(s_x+s_y)="+(-(s_x+s_y)));

std.print("\n\n---logical operator usage");
x = 3;
y = 5;
std.print ("x<y = "+(x<y));
std.print ("x>=y = "+(x>=y));
std.print ("x>y = "+(x>y));
std.print ("x>=y = "+(x>=y));
std.print ("x==y = "+(x==y));
std.print ("x!=y = "+(x!=y));
std.print ("!(x==y) = "+(!(x==y)));
std.print ("x<y&&x>y = "+(x<y&&x>y));
std.print ("x<y||x>y = "+(x<y||x>y));
std.print ("x>2&&y>3&&y<5 = "+(x>2&&y>3&&y<5));


std.print("\n\n---control flow");
x = 0;
while (x<100) {
  if (x<5) {
    std.print("x="+x+";x<"+5);
  } elseif (x<6) {
     std.print("x="+x+";x<6");
  } else {
     if (x<8) {
       std.print("  x="+x+";x<8");
     } else {
       std.print("  x="+x+";x>8");
     }
  }
  x = x+1;
    if (x==10) {
        break;
    }
}


std.print("\n\n---string");
x = "this is a 字符串";
std.print("x= "+x);

std.print("length="+x.length());
std.print("startsWith 'this'?: "+x.startsWith("this"));
std.print("contains 'a'?: "+x.contains("a"));
std.print("substring(1 5): "+x.substring(1,5));
std.print("format('%s %ld'): "+x.format("%s %d","format int",5));
std.print("splitByRegex('\\s+'): "+x.splitByRegex("\\s+"));
std.print("matchersOfRegex('\\S+'): "+x.matchesOfRegex("\\S+"));

y = "124t";
std.print("'124t'.toInt(): "+y.toInt());

x = x.replace("a", "another");
std.print(x);
std.print(x.replaceRegex("\\b[a-z]+\\b","word"));
x = "   before trim   ";
std.print(x);
std.print(x.trim());


x = "this \\ \n \t \r is a 转义字符串";
std.print(x);


std.print("\n\n---list");
x = "key";
y = "value";
std.print(@[x,y,"abc","efg"]);


y = @[];
y.add("nss");
y.add("yys");
std.print(y);
y.addAll(@["zzz","jjj"]);
std.print(y);
std.print(y.size());
std.print(y.joinToString("*"));


std.print("\n\n---dict");
x = "key";
y = "value";
std.print(@{x:y,"abc":"efg"});
y = @{};
y.put("abc","efg");
y.put("dst","hhm");
y.putAll(@{"kkk":"vvv"});
y.putKeyValues("k1","v1","k2","v2");
std.print(y);
std.print("y.allKeys(): "+y.allKeys());
std.print("y.allValues(): "+y.allValues());
std.print(y.size());

std.print("\n\n---extern class type");
obj = new DemoClass;
obj.stringProperty = "abc";
std.print(obj.stringProperty);
//std.print(obj.doSomething(y));


std.print("\n\n---error handle");
var x;
//std = "";
